# RPM packaging of the GNOME Shell extension Activities Configurator

This package spec is for Activities Configurator, which has its own GNOME Shell
[extension page](https://extensions.gnome.org/extension/358/activities-configurator/)
and source code [repository](https://github.com/nls1729/acme-code).

Activities Configurator gives you all sorts of options to control the look and
feel of the top bar and Activities button in GNOME Shell, possibly even
overriding your current Shell theme. You can change or remove the Activities
button text, add an icon, move it to right corner, change the top bar's
background color and transparency... You can toggle the Overview if no
applications are running (at login and whenever the last application window is
closed). You can also adjust the "pressure" threshold for the hot corner, or
disable it altogether.

**NOTE:** After installing, each user that wants it must still manually enable
Activities Configurator before it will take effect. You can do so a few
different ways:

* If you've already installed the GNOME Shell integration web browser plugin,
	go to <https://extensions.gnome.org/local/>, find the extension, and click
	the switch to "ON."
* Open GNOME Tweak Tool, go to the Extensions tab, find the extension, and click
	the switch to "ON."
* Open a terminal or the desktop's command dialog, and (as your normal user
	account) run: `gnome-shell-extension-tool --enable activities-config@nls1729`

You may also need to restart GNOME Shell (Open the command dialog with Alt-F2,
type `r`, and hit enter), or log out and log back in.



## Bug reports and feature requests

Report any issues with Activities Configurator itself on the project's
[GitHub](https://github.com/nls1729/acme-code/issues).

Report issues specific to this package on the
[Red Hat Bugzilla](https://bugzilla.redhat.com/buglist.cgi?product=Fedora&component=gnome-shell-extension-activities-configurator).



## License

Everything specific to this repository uses the MIT License.

Activities Configurator itself uses the GNU GPL version 2.
